Bayesian hacker chapter 1 use edward


#1
import pymc3 as pm
import theano.tensor as tt

with pm.Model() as model:
    alpha = 1.0/count_data.mean()  # Recall count_data is the
                               # variable that holds our txt counts
    lambda_1 = pm.Exponential("lambda_1", alpha)
    lambda_2 = pm.Exponential("lambda_2", alpha)

    tau = pm.DiscreteUniform("tau", lower=0, upper=n_count_data - 1)


with model:
    idx = np.arange(n_count_data) # Index
    lambda_ = pm.math.switch(tau >= idx, lambda_1, lambda_2)
    observation = pm.Poisson("obs", lambda_, observed=count_data)
    step = pm.Metropolis()
    trace = pm.sample(10000, tune=5000,step=step)

and use edward :

 import edward as ed
import tensorflow as tf
from edward.models import Exponential,Uniform,Poisson,Empirical
from edward.models import PointMass

alpha_f = 1.0/count_data.mean()


alpha = tf.Variable(alpha_f, name="alpha", dtype=tf.float32)

# init 
lambda_1 = Exponential(alpha)
lambda_2 = Exponential(alpha)
tau = Uniform(low=0.0,high=float(n_count_data - 1))
idx = np.arange(n_count_data)
lambda_ = tf.where(tau>=idx,tf.ones(shape=[n_count_data],dtype=tf.float32)*lambda_1,tf.ones(shape=[n_count_data],dtype=tf.float32)*lambda_2)


z = Poisson(lambda_,value=count_data)
T = 5000
qlambda_1 =  Empirical(params=tf.Variable(tf.zeros([T])))
qlambda_2 =  Empirical(params=tf.Variable(tf.zeros([T])))
qtau = Empirical(params=tf.Variable(tf.zeros([T])))
qz = Empirical(params=tf.Variable(tf.zeros([T,n_count_data])))

inference = ed.HMC({z:qz,lambda_1:qlambda_1,lambda_2:qlambda_2,tau:qtau})
inference.run()

but when i run this n_iter:

for t in range(inference.n_iter):
    info_dict = inference.update()
    print(info_dict)

throw error:

 InvalidArgumentError                      Traceback (most recent call last)
c:\python35\lib\site-packages\tensorflow\python\client\session.py in _do_call(self, fn, *args)
   1138     try:
-> 1139       return fn(*args)
   1140     except errors.OpError as e:

c:\python35\lib\site-packages\tensorflow\python\client\session.py in _run_fn(session, feed_dict, fetch_list, target_list, options, run_metadata)
   1120                                  feed_dict, fetch_list, target_list,
-> 1121                                  status, run_metadata)
   1122 

c:\python35\lib\contextlib.py in __exit__(self, type, value, traceback)
     65             try:
---> 66                 next(self.gen)
     67             except StopIteration:

c:\python35\lib\site-packages\tensorflow\python\framework\errors_impl.py in raise_exception_on_not_ok_status()
    465           compat.as_text(pywrap_tensorflow.TF_Message(status)),
--> 466           pywrap_tensorflow.TF_GetCode(status))
    467   finally:

InvalidArgumentError: indices = 5000 is not in [0, 5000)
     [[Node: ScatterUpdate_26 = ScatterUpdate[T=DT_FLOAT, Tindices=DT_INT32, _class=["loc:@Variable_77"], use_locking=true, _device="/job:localhost/replica:0/task:0/cpu:0"](Variable_77, iteration_17/read, cond_17/Merge_3)]]

During handling of the above exception, another exception occurred:

InvalidArgumentError                      Traceback (most recent call last)
<ipython-input-107-2c42d8ad11c6> in <module>()
     30 
     31 for t in range(inference.n_iter):
---> 32     info_dict = inference.update()
     33     print(info_dict)
     34 

c:\python35\lib\site-packages\edward\inferences\monte_carlo.py in update(self, feed_dict)
    135 
    136     sess = get_session()
--> 137     _, accept_rate = sess.run([self.train, self.n_accept_over_t], feed_dict)
    138     t = sess.run(self.increment_t)
    139 

c:\python35\lib\site-packages\tensorflow\python\client\session.py in run(self, fetches, feed_dict, options, run_metadata)
    787     try:
    788       result = self._run(None, fetches, feed_dict, options_ptr,
--> 789                          run_metadata_ptr)
    790       if run_metadata:
    791         proto_data = tf_session.TF_GetBuffer(run_metadata_ptr)

c:\python35\lib\site-packages\tensorflow\python\client\session.py in _run(self, handle, fetches, feed_dict, options, run_metadata)
    995     if final_fetches or final_targets:
    996       results = self._do_run(handle, final_targets, final_fetches,
--> 997                              feed_dict_string, options, run_metadata)
    998     else:
    999       results = []

c:\python35\lib\site-packages\tensorflow\python\client\session.py in _do_run(self, handle, target_list, fetch_list, feed_dict, options, run_metadata)
   1130     if handle is None:
   1131       return self._do_call(_run_fn, self._session, feed_dict, fetch_list,
-> 1132                            target_list, options, run_metadata)
   1133     else:
   1134       return self._do_call(_prun_fn, self._session, handle, feed_dict,

c:\python35\lib\site-packages\tensorflow\python\client\session.py in _do_call(self, fn, *args)
   1150         except KeyError:
   1151           pass
-> 1152       raise type(e)(node_def, op, message)
   1153 
   1154   def _extend_graph(self):

InvalidArgumentError: indices = 5000 is not in [0, 5000)
     [[Node: ScatterUpdate_26 = ScatterUpdate[T=DT_FLOAT, Tindices=DT_INT32, _class=["loc:@Variable_77"], use_locking=true, _device="/job:localhost/replica:0/task:0/cpu:0"](Variable_77, iteration_17/read, cond_17/Merge_3)]]

Caused by op 'ScatterUpdate_26', defined at:
  File "c:\python35\lib\runpy.py", line 193, in _run_module_as_main
    "__main__", mod_spec)
  File "c:\python35\lib\runpy.py", line 85, in _run_code
    exec(code, run_globals)
  File "c:\python35\lib\site-packages\ipykernel_launcher.py", line 16, in <module>
    app.launch_new_instance()
  File "c:\python35\lib\site-packages\traitlets\config\application.py", line 658, in launch_instance
    app.start()
  File "c:\python35\lib\site-packages\ipykernel\kernelapp.py", line 477, in start
    ioloop.IOLoop.instance().start()
  File "c:\python35\lib\site-packages\zmq\eventloop\ioloop.py", line 177, in start
    super(ZMQIOLoop, self).start()
  File "c:\python35\lib\site-packages\tornado\ioloop.py", line 888, in start
    handler_func(fd_obj, events)
  File "c:\python35\lib\site-packages\tornado\stack_context.py", line 277, in null_wrapper
    return fn(*args, **kwargs)
  File "c:\python35\lib\site-packages\zmq\eventloop\zmqstream.py", line 440, in _handle_events
    self._handle_recv()
  File "c:\python35\lib\site-packages\zmq\eventloop\zmqstream.py", line 472, in _handle_recv
    self._run_callback(callback, msg)
  File "c:\python35\lib\site-packages\zmq\eventloop\zmqstream.py", line 414, in _run_callback
    callback(*args, **kwargs)
  File "c:\python35\lib\site-packages\tornado\stack_context.py", line 277, in null_wrapper
    return fn(*args, **kwargs)
  File "c:\python35\lib\site-packages\ipykernel\kernelbase.py", line 283, in dispatcher
    return self.dispatch_shell(stream, msg)
  File "c:\python35\lib\site-packages\ipykernel\kernelbase.py", line 235, in dispatch_shell
    handler(stream, idents, msg)
  File "c:\python35\lib\site-packages\ipykernel\kernelbase.py", line 399, in execute_request
    user_expressions, allow_stdin)
  File "c:\python35\lib\site-packages\ipykernel\ipkernel.py", line 196, in do_execute
    res = shell.run_cell(code, store_history=store_history, silent=silent)
  File "c:\python35\lib\site-packages\ipykernel\zmqshell.py", line 533, in run_cell
    return super(ZMQInteractiveShell, self).run_cell(*args, **kwargs)
  File "c:\python35\lib\site-packages\IPython\core\interactiveshell.py", line 2718, in run_cell
    interactivity=interactivity, compiler=compiler, result=result)
  File "c:\python35\lib\site-packages\IPython\core\interactiveshell.py", line 2822, in run_ast_nodes
    if self.run_code(code, result):
  File "c:\python35\lib\site-packages\IPython\core\interactiveshell.py", line 2882, in run_code
    exec(code_obj, self.user_global_ns, self.user_ns)
  File "<ipython-input-107-2c42d8ad11c6>", line 27, in <module>
    inference.run()
  File "c:\python35\lib\site-packages\edward\inferences\inference.py", line 123, in run
    self.initialize(*args, **kwargs)
  File "c:\python35\lib\site-packages\edward\inferences\hmc.py", line 64, in initialize
    return super(HMC, self).initialize(*args, **kwargs)
  File "c:\python35\lib\site-packages\edward\inferences\monte_carlo.py", line 98, in initialize
    self.train = self.build_update()
  File "c:\python35\lib\site-packages\edward\inferences\hmc.py", line 116, in build_update
    assign_ops.append(tf.scatter_update(variable, self.t, sample[z]))
  File "c:\python35\lib\site-packages\tensorflow\python\ops\gen_state_ops.py", line 599, in scatter_update
    name=name)
  File "c:\python35\lib\site-packages\tensorflow\python\framework\op_def_library.py", line 767, in apply_op
    op_def=op_def)
  File "c:\python35\lib\site-packages\tensorflow\python\framework\ops.py", line 2506, in create_op
    original_op=self._default_original_op, op_def=op_def)
  File "c:\python35\lib\site-packages\tensorflow\python\framework\ops.py", line 1269, in __init__
    self._traceback = _extract_stack()

InvalidArgumentError (see above for traceback): indices = 5000 is not in [0, 5000)
     [[Node: ScatterUpdate_26 = ScatterUpdate[T=DT_FLOAT, Tindices=DT_INT32, _class=["loc:@Variable_77"], use_locking=true, _device="/job:localhost/replica:0/task:0/cpu:0"](Variable_77, iteration_17/read, cond_17/Merge_3)]]

Bayesian hacker chapter1_introduction imp use edward
#2

I replied in Bayesian hacker chapter1_introduction imp use edward.